excalibur/website/models/base.py
# Copyright (c) 2019 by Star Lab Corp.

# coding: utf-8

from contextlib import contextmanager
from flask import g, current_app
from flask_sqlalchemy import SQLAlchemy as _SQLAlchemy
from werkzeug.local import LocalProxy
from cachelib.file import FileSystemCache


class SQLAlchemy(_SQLAlchemy):
    @contextmanager
    def auto_commit(self, throw=True):
        try:
            yield
            self.session.commit()
        except Exception as e:
            self.session.rollback()
            if throw:
                raise e


db = SQLAlchemy()


class Base(db.Model):
    __abstract__ = True


def _get_cache():
    _cache = g.get('_oauth_cache')
    if _cache:
        return _cache
    _cache = FileSystemCache(current_app.config['OAUTH_CACHE_DIR'])
    g._oauth_cache = _cache
    return _cache


cache = LocalProxy(_get_cache)

excalibur/website/forms/base.py
# Copyright (c) 2019 by Star Lab Corp.

from flask_wtf import FlaskForm
from flask_wtf._compat import string_types
from wtforms.widgets import HiddenInput


class BaseForm(FlaskForm):
    def hidden_fields(self):
        for field in self._fields:
            if isinstance(field, string_types):
                field = getattr(self, field, None)
            if field and isinstance(field.widget, HiddenInput):
                yield field

    def visible_fields(self):
        for field in self._fields:
            if isinstance(field, string_types):
                field = getattr(self, field, None)

            if field and not isinstance(field.widget, HiddenInput):
                yield field

excalibur/website/routes/account.py
# Copyright (c) 2019 by Star Lab Corp.

from flask import Blueprint
from flask import url_for, redirect, render_template
from ..auth import current_user, logout as _logout
from ..forms.user import AuthenticateForm, UserCreationForm

bp = Blueprint('account', __name__)

# CONVERT to LDAP:
# from flask.ext.login import []
# def load_user


@bp.route('/login', methods=['GET', 'POST'])
def login():
    # if current_user.is_authenticated():
    if current_user:
        return redirect(url_for('front.home'))
    print('WAT    : AuthenticateForm()')
    form = AuthenticateForm()
    if form.validate_on_submit():
        print('WAT    : form.login()')
        form.login()
        return redirect(url_for('front.home'))
    return render_template('account/login.html', form=form)


@bp.route('/logout')
def logout():
    _logout()
    return redirect(url_for('front.home'))


@bp.route('/signup', methods=['GET', 'POST'])
def signup():
    if current_user:
        return redirect(url_for('front.home'))
    form = UserCreationForm()

    if form.validate_on_submit():
        form.signup()
        return redirect(url_for('front.home'))

    return render_template('account/signup.html', form=form)

excalibur/website/routes/client.py
# Copyright (c) 2019 by Star Lab Corp.

from flask import Blueprint, url_for
from flask import abort, redirect, render_template
from ..auth import require_login, current_user
from ..models import OAuth2Client
from ..forms.client import (Client2Form, OAuth2ClientWrapper)

bp = Blueprint('client', __name__)


@bp.route('')
@require_login
def list_clients():
    q = OAuth2Client.query.filter_by(user_id=current_user.id)
    oauth2_clients = q.order_by(OAuth2Client.id.desc()).limit(50).all()
    return render_template(
        'client/list.html',
        oauth2_clients=oauth2_clients,
    )


@bp.route('/<int:version>/create', methods=['GET', 'POST'])
@require_login
def create_client(version):
    form = Client2Form()

    if form.validate_on_submit():
        form.save(current_user)
        return redirect(url_for('.list_clients'))
    return render_template('client/create.html', form=form)


@bp.route('/<int:version>/<client_id>', methods=['GET', 'POST'])
@require_login
def edit_client(version, client_id):
    client = OAuth2Client.query.filter_by(client_id=client_id).first()
    print('WAT    : REDIRECT_URIS - bp.route    : %s' % ''.join(
        client.redirect_uris))
    if not client or client.user_id != current_user.id:
        abort(404)
    form = Client2Form(obj=OAuth2ClientWrapper(client))

    if form.validate_on_submit():
        form.update(client)
        return redirect(url_for('.list_clients'))
    return render_template('client/edit.html', form=form)

excalibur/website/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width,initial-scale=1,maximum-scale=1">
  <title>{% block title %}VirtUE Excalibur{% endblock %}</title>
  <link rel="shortcut icon" href="//authlib.org/favicon.ico">
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,400,700">
  {% for src in assets.base.styles %}
    <link rel="stylesheet" href="{{ src }}">
  {% endfor %}
  {% block extrahead %}{% endblock %}
</head>
<body>
{% block nav %}
  <header class="head" style="margin-top:80px">
    <div class="inner">
      <h1>VirtUE Excalibur</h1>
      {% if current_user %}
        <nav>
          <a href="/">Home</a>
          <a href="{{ url_for('client.list_clients') }}">Apps</a>
        </nav>
      {% endif %}
    </div>
  </header>
{% endblock %}
{% block body %}{% endblock %}
</body>
</html>

excalibur/website/templates/home.html
{% extends "base.html" %}

{% block body %}
  <section class="section">
    <div class="inner">
      {% if current_user %}
        <p>You are logged in as <strong>{{ current_user.name }}</strong></p>
        <div class="account_actions">
          <a href="{{ url_for('account.logout') }}" class="btn">Log Out</a>
          <a href="{{ url_for('client.list_clients') }}" class="btn">Apps</a>
        </div>
      {% else %}
        <p>You need to log in to access Excalibur Resources.</p>
        <div class="account_actions">
          <a href="{{ url_for('account.login') }}" class="btn">Log In</a>
        </div>
      {% endif %}
    </div>
   </section>
  </footer>
{% endblock %}

excalibur/website/templates/macros.html
{% macro render_field(field, label_html=None) %}
  <div class="form-field{% if field.errors %} has-errors{% endif %}">
    {% if label_html %}
      <span><label>{{ label_html|safe }}</label></span>
    {% else %}
      <span>{{ field.label() }}</span>
    {% endif %}
    {% if field.flags.required %}
      {{ field(class_="form-field_input", required=True) }}
    {% else %}
      {{ field(class_="form-field_input") }}
    {% endif %}
    {% if field.errors %}
      <ul class="form-field_errors">
        {% for error in field.errors %}
          <li>{{ error }}</li>
        {% endfor %}
      </ul>
    {% endif %}
  </div>
{% endmacro %}

{% macro render_form(form) %}
  {% for field in form.hidden_fields() %}
    {{ field }}
  {% endfor %}
  {% for field in form.visible_fields() %}
    {{ render_field(field) }}
  {% endfor %}
{% endmacro %}